/* Parser for simple Roman Numeral recognizer */

/* Very little error checking is done.  Although this should
   properly evaluate any legal Roman numeral, it will also
   produce silly results for improperly formulated ones.
 */

%{
#include "globals.h"
#include <iostream>

using namespace std;
%}

%union
{
	int digit;
	intpair value;
}

%token <digit> TERM
%type <value> final, roman

%%

final:		roman	{ cout << $1.total << endl; }

roman	:	TERM	{ $$.total = $1; $$.digit = $1; }
	|	TERM roman	{
					if ( $1 < $2.digit )
						$$.total = $2.total - $1;
					else
						$$.total = $2.total + $1;
					$$.digit = $1;
				}

%%

int yyerror ( char *msg )
{
	cout << "Syntax Error:" << msg << endl;
}
